program nkhotkey;

uses Windows, Messages, NLib, NSys, Main, NotifyIcon;

{$R *.RES}

var
  msg: TMsg;
  r: Integer;
begin
  try
    if CreateMutex(nil, True, PChar(AppName+'Mutex')) = 0 then
      raise EOSError.Create;
    if GetLastError = ERROR_ALREADY_EXISTS then
    begin
      MsgBox('Already run.');
      Exit;
    end;
    MainWnd := MakeWindow;
    AddNotifyIcon;
  except
    on E: EOSError do
    begin
      MsgBox(E.Msg);
      Exit;
    end;
  end;

  ChDir(DirName(ProgPath));

  ProfDir := GetEnv('NKTOOLSPROF');
  if ProfDir = '' then
    ProfDir := DirName(ProgPath)
  else
    ProfDir := JoinPath([ProfDir, 'nkhotkey']);

  KeymapFilePath := JoinPath([ProfDir, 'keymap']);
  UpdateHotKeys;

  try
    while True do
    begin
      r := Integer(GetMessage(msg, 0, 0, 0));
      if r = -1 then
        raise EOSError.Create;
      if r = 0 then
        Break;
      DispatchMessage(msg);
    end;
  except
    on E: EOSError do MsgBox(E.Msg);
  end;

  DeleteNotifyIcon;
  ClearHotKeys;
  DestroyWindow(MainWnd);
end.
