unit NrLib;

interface

uses NTypes, NLib, NSys;

type
  TGetValueFunc = function (const Name: string): TStringArray;
  ETypeError = class(TObject);

function Expand(const Args: array of string; GetValue: TGetValueFunc):
    TStringArray;

implementation

procedure ExtendArray(var A: TStringArray; const B: array of string);
var
  i, len: Integer;
begin
  if Length(B) = 0 then
    Exit;
  len := Length(A);
  SetLength(A, len + Length(B));
  for i := 0 to High(B) do
    A[len+i] := B[i];
end;

procedure Add(var A: TStringArray; const B: array of string);
var
  i: Integer;
  s: string;
begin
  if Length(B) = 0 then
    Exit;
  if Length(A) = 0 then
    A := StringArray(B)
  else if Length(A) = Length(B) then
    for i := 0 to High(A) do
       A[i] := A[i] + B[i]
  else if Length(A) = 1 then
  begin
    s := A[0];
    SetLength(A, Length(B));
    for i := 0 to High(B) do
       A[i] := s + B[i];
  end
  else if Length(B) = 1 then
    for i := 0 to High(A) do
       A[i] := A[i] + B[0]
  else
    raise ETypeError.Create;
end;

function Expand1(const S: string; GetValue: TGetValueFunc): TStringArray;
const
  delims =
    [#$00..#$1f, ' ', '!', '#'..')', '+'..'/', ':'..'@', '['..'\','{'..#$7f];
var
  sym: string;
  i: Integer;
  q, qq: Boolean;
  m: TMChar;
begin
  Result := nil;
  q := False;
  qq := False;
  sym := '';
  i := 1;
  while EachChar(S, i, m) do
  begin
    if qq then
    begin
      sym := sym + m;
      qq := False;
      Continue;
    end;

    if q then
    begin
      if m = '"' then
      begin
        if sym <> '' then
        begin
          Add(Result, GetValue(sym));
          sym := '';
        end;
        q := False
      end else
        sym := sym + m;
    end
    else if m[0] = '"' then
    begin
      if S[i] = '"' then
      begin
        qq := True;
        Continue;
      end;
      q := True
    end
    else if m[0] in delims then
    begin
      if sym <> '' then
        Add(Result, GetValue(sym));
      sym := m;
    end else
      sym := sym + m;
  end;
  if sym <> '' then
    Add(Result, GetValue(sym));
end;

function Expand(const Args: array of string; GetValue: TGetValueFunc):
    TStringArray;
var
  i: Integer;
begin
  Result := nil;
  for i := 0 to High(Args) do
    ExtendArray(Result, Expand1(Args[i], GetValue));
end;

end.
